<template>
    <Card id="pick-location-panel">
        <div style="text-align:center">
                <h4>CHỌN ĐIỂM</h4>
                <h5>Bấm vào bản đồ để chọn điểm</h5>
                <!--<Input v-model="stringLocation" placeholder="Gõ tên địa điểm ..." style="width: 300px" />-->
                <Button type="primary" icon="ios-locate-outline" @click="getMyLocation()">Lấy Vị trí của tôi</Button>
                <p id="displayResult">Tọa độ địa điểm là</p>
                <p id="displayResult">{{googlePos.lat()}} - {{googlePos.lng()}}</p>
                <Button type="success" class="btnAction" @click="close()">Xác nhận & Đóng</Button>
        </div>
    </Card>
</template>
<script>
    import { getCurrentPosition } from '@/Utils/getCurrentPosition'

    export default {
        data() {
            return {
                stringLocation: "",
                currentMarker: {},
                googlePos: {},
                mapClickEvent: {}
            }
        },
        mounted() {
            this.googlePos=this.$store.state.map.getCenter();
            this.currentMarker = new window.google.maps.Marker({
                map: this.$store.state.map,
                position: this.googlePos,
                // draggable: true,
                animation: window.google.maps.Animation.DROP
            });
            this.mapClickEvent = this.$store.state.map.addListener('click', this.listenClick);
        },
        unmounted() {
            this.$store.state.map.removeListener(this.mapClickEvent);
        },
        props: {
            value: Object
        },
        methods: {
            listenClick: function(e) {
                this.googlePos = e.latLng;
                this.currentMarker.setPosition(this.googlePos);
            },
            getMyLocation: async function() {
                let pos = await getCurrentPosition();
                this.googlePos = new window.google.maps.LatLng(pos.coords.latitude, pos.coords.longitude)
                this.$store.state.map.panTo(this.googlePos);
                this.$store.state.map.setZoom(16);
                this.currentMarker.setPosition(this.googlePos);
            },
            close: function() {
                this.currentMarker.setMap(null)
                this.$emit('input', this.googlePos)
                this.$emit('close')
            }
        }
    }
</script>
<style>
    #pick-location-panel {
        position: fixed;
        top: 0px;
        width: 100%;
        height: 100%;
    }

    #displayResult {
        margin: 10px;
    }
</style>
